;*********************************************************************************************
;
;	ABIT PW4 BIOS MODIFICATION
;
;	By Oerg866
;
;	BASED ON OFFICIAL BIOS VERSON 2E
;
;*********************************************************************************************

    .model tiny
    .286

; Some shit we need:

A8259		EQU 20h			; first 8259
B8259		EQU	0a0h			; second (slave) 8259
END_OF_INT	EQU	20h			; end of interrupt code
DATA8042	EQU	60h
STAT8042	EQU	64h
IBF_8042	EQU	00000010b		; Input buffer full on 8042
OBF_8042	EQU	00000001b		; Output buffer full on 8042
OBF_AUX		EQU	00100000b		; auxiliary device output buffer full	
OBF_MS		EQU	00100001b		; mouse output buffer full		
MOBF		EQU	00100001b		; Mouse Output Buffer Full		
WRITE_CMD	EQU	60h

CONFIG_TABLE        EQU	0E6F5h

IRQ12_OLD		    EQU 0D590h

G_RAM		SEGMENT	AT 0H
    ORG 400H
COMM_PORT_ADDRS		DW	4 DUP(?)	;40:00			
PRNTR_PORT_ADDRS	DW	3 DUP(?)	;40:08
EXT_SEGMENT		DW	?		;40:0E
HARDWARE		DW	1 DUP(?)	;40:10
INIT_FLG		DB	1 DUP(?)	;40:12
SIZE_SYSRAM		DW	1 DUP(?)	;40:13
INIT_ERR_FLG		DW	1 DUP(?)	;40:15
SHFT_STAT		DB	1 DUP(?)	;40:17
KBD_FLG1		DB	1 DUP(?)	;40:18
ALT_INPUT		DB	1 DUP(?)	;40:19
PTR_KBD_BUF_HD		DW	1 DUP(?)	;40:1A	; POINTERS FOR BUF_FOR_KBD
PTR_KBD_BUF_TL		DW	1 DUP(?)	;40:1C
BUF_FOR_KBD		DW	16 DUP(?)	;40:1E	; TYPE AHEAD BUFFER
NEED_RECAL		DB	1 DUP(?)	;40:3E	; DRIVE RECALIBRATION FLAG
MOTOR_ON_IND		DB	1 DUP(?)	;40:3F
MOTOR_OFF_WAIT		DB	1 DUP(?)	;40:40
FD_OP_RESULT		DB	1 DUP(?)	;40:41	; FLOPPY DISK STATUS

FDC_RET_CODES		LABEL	BYTE		;40:42	; FLOPPY DISK RETURN CODES
HDC_CMD			DB	6 DUP(?)	;40:42	; HARD DISK COMMAND BLOCK
FDC_RET_END		DB	1 DUP(?)	;40:48	; MARKER ONLY LENGTH 7 BLOCK
CON_MODE		DB	1 DUP(?)	;40:49	; CURRENT MODE
CON_COLS		DW	1 DUP(?)	;40:4A	; # OF COLUMNS ON SCREEN
CON_LEN			DW	1 DUP(?)	;40:4C	; LENGTH OF SCREEN
CON_STR			DW	1 DUP(?)	;40:4E	; BASE ADDRESS OF SCREEN
CUR_POS			DW	8 DUP(?)	;40:50	; CURSOR POSITION FOR 8 PAGES
CURSOR_MODE		DW	1 DUP(?)	;40:60	; CURSOR MODE SETTING
ACT_PAGE		DB	1 DUP(?)	;40:62	; PAGE BEING DISPLAYED
CARD_ADDR		DW	1 DUP(?)	;40:63	; BASE ADDRESS OF DISPLAY CARD
CON_MODE_SET		DB	1 DUP(?)	;40:65
CON_PALETTE		DB	1 DUP(?)	;40:66
ROM_MODULE_OFFSET	DW	1 DUP(?)	;40:67
ROM_MODULE_SEG		DW	1 DUP(?)	;40:69
INT_OCCUR_FLG		DB	1 DUP(?)	;40:6B
LOW_8254_CNT		DW	1 DUP(?)	;40:6C
HI_8254_CNT		DW	1 DUP(?)	;40:6E
OVRFLW_8254		DB	1 DUP(?)	;40:70
BIOS_BRK		DB	1 DUP(?)	;40:71	; AKBRD
USER_REBOOT		DW	1 DUP(?)	;40:72	; RESET_FLG change in atorgs
DISK_STAT		DB	1 DUP(?)	;40:74	; HARD DISK STATUS
NUMHDSKS		DB	1 DUP(?)	;40:75
HDC_CNTL		DB	1 DUP(?)	;40:76	; HARD DISK CONTROL BYTE
			DB	1 DUP(?)	;40:77
PARL_PORT_TO_CNT	DW	2 DUP(?)	;40:78	; added from orgs
COMM_PORT_TO_CNT	DW	2 DUP(?)	;40:7C
KBD_BUF_LOCN		DW	1 DUP(?)	;40:80
KBD_BUFEND_LOCN		DW	1 DUP(?)	;40:82

CON_LLINE		LABEL	BYTE		;40:84		; last row of video screen.
CON_ROWS		DB	7 DUP(?)	;40:84

XFER_INFO		LABEL	BYTE		;40:8B
MOST_RECENT_RATE	DB	1 DUP(?)	;40:8B
HDC_STAT_RES		DB	1 DUP(?)	;40:8C	; HARD DISK STATUS RESULTS
HDC_ERR_RES		DB	1 DUP(?)	;40:8D	; HARD DISK ERROR RESULTS
HDC_INT			DB	1 DUP(?)	;40:8E	; HARD DISK INTERRUPT
DCAPABILITY		DB	1 DUP(?)	;40:8F
CURRENT_MEDIA		DB	2 DUP (?)	;40:90
			DB	2 DUP (?)	;40:92
CURCYL			DB	2 DUP(?)	;40:94	; FLOPPY CURRENT CYLINDER
KB_FLAG_3		DB	1 DUP(?)	;40:96	; NEW 101 KEYBOARD FLAG
KB_FLAG_2		LABEL	BYTE		;40:97	; NEW 101 OVERLAY
LED_STAT		DB	1 DUP(?)	;40:97
REQUESTER_FLG_OFFSET	DW	1 DUP(?)	;40:98
REQUESTER_SEG		DW	1 DUP(?)	;40:9A
LOW_NUM_MSECS		DW	1 DUP(?)	;40:9C
HI_NUM_MSECS		DW	1 DUP(?)	;40:9E
WAIT_IN_USE		DB	1 DUP(?)	;40:A0
TEMP_BP			DW	1 DUP(?)	;40:A1	; SAVE POST BP		
			DB      9 DUP(?)	;40:A3  ; A3,A4,A5,A6,A7,A8,A9,AA,AB 	
G_RAM		ENDS

;EXT_SEGMENT         EQU 40Eh
;HARDWARE            EQU 410h

MS_RSTSCL	    EQU	0E6h		; reset scaling to 1:1
MS_SETSCL	    EQU	0E7h		; set scaling 2:1
MS_SETRES	    EQU	0E8h		; set resolution
MS_STSREQ	    EQU	0E9h		; status request
MS_SETSTRMD	    EQU	0EAh		; set stream mode
MS_RDDATA	    EQU	0EBh		; read data
MS_RSTWRPMD	    EQU	0ECh		; reset wrap mode
MS_SETWRPMD	    EQU	0EEh		; set wrap mode
MS_SETREMOTE	EQU	0F0h		; set remote mode
MS_RDTYPE	    EQU	0F2h		; read device type
MS_SETRATE	    EQU	0F3h		; set sampling rate
MS_ENDATA	    EQU	0F4h		; enable data transfer in stream mode
MS_DISDATA	    EQU	0F5h		; disable data transfer in stream mode
MS_SETDEF	    EQU	0F6h		; set default
MS_RESEND	    EQU	0FEh		; resend
MS_RESET	    EQU	0FFh		; reset

; Mouse code identify

SUCCODE 	EQU	0AAh		; self test successful
RSCODE		EQU	0FEh		; resend
ACKCODE 	EQU	0FAh		; acknowledge
ERRCODE 	EQU	0FCh		; error

FCOFFSET	EQU	22h	;22 = Device Driver Far Call Offset (Word)
FCSEGMENT	EQU 24h	;24 = Device Driver Far Call Segment (Word)
PDFLG_1		EQU	26h	;26 = Pointing Device Flag (1st Byte)
PDFLG_2		EQU	27h	;27 = Pointing Device Flag (2nd Byte)
AUXDATA		EQU	28h	;28-2F = Auxiliary Data Buffer

; Device Driver Flag identify

; PDFLG_1 EQUATES: 1st byte

CIPFLG		EQU	10000000b	; Command In Progress flag
RSFLG		EQU	01000000b	; ReSend flag
ACKFLG		EQU	00100000b	; ACKnowledge flag
ERRFLG		EQU	00010000b	; ERRor flag

; PDFLG_2 EQUATES: 2nd byte

DDFCFLG 	EQU	10000000b	; Device Driver Far Call flag

FAR_JMP     MACRO SEGMENT, OFFSET
            DB 0EAh
            dw OFFSET
            dw SEGMENT
            ENDM

FAR_CALL    MACRO SEGMENT, OFFSET
            DB 090h, 09Ah
            DW OFFSET
            DW SEGMENT
            ENDM

POSTCODE	MACRO CODE
		    push ax
            mov al, CODE
            out 80h, al
            pop ax
		    ENDM

SIODELAY	MACRO				; SHORT IODELAY
		    jmp	short $+2
		    ENDM

IODELAY		MACRO				; NORMAL IODELAY
		    siodelay
		    siodelay
		    ENDM

WAFORIO		MACRO				; NORMAL IODELAY
		    siodelay
		    siodelay
		    siodelay
		    siodelay
		    siodelay
		    siodelay
		    ENDM

NEWIODELAY  MACRO
		    ;out	0ebh,al              
	       	out 0e1h, al
            ENDM  

BASEMEM     SEGMENT USE16 AT 0
    ORG 021A9h
FAR_Three_Freq::
BASEMEM     ENDS

BIOS		SEGMENT	AT 0F000H
BIOS        ENDS

FCODE		SEGMENT	 USE16 Public 'CODE'
	ASSUME CS:BIOS

    include BASEROM.INC

;****************************************************************************
; BIOS String hack
;****************************************************************************

    ORG 0E0C1h
    DB 'ABIT PW4 MOD BIOS by ', 6, 'Eric Voirin (Oerg866)', 8, 0

    ORG 0EC71h
;   DB '09/12/95-Winbond-83C491-2C4J6A12-2E'
    DB '27/03/2024-', 6, 'oerg866', 8, '-ABIT-PW4-V1.0 '

    ORG 0E0F0h
TheRetroWebStr::
    DB 'http://', 6, 'theretroweb', 8, '.com/'

; Add RetroWeb string display on POST screen

    ORG 0115Dh
Show_CS_String::
    ORG 02880h
VCRLF::

    ORG 00EF5h
    call StringDisplayHack  

    ORG 0F820h
StringDisplayHack::
    call Show_CS_String ; Display banner MSG
    call VCRLF          ; New line
    mov si, offset TheRetroWebStr
    call Show_CS_String ; Display TheRetroWeb string
    call VCRLF
    retn

;****************************************************************************
; BIOS Checksum defeat
;****************************************************************************

;	Defeat the checksum check
;		0A89	jz short 0xA93				74 08				-> EB 08

    ORG     0A89h
;   jz      short loc_F0A93
    jmp short loc_F0A93
    or      byte ptr [bp+3Fh], 1            ; Flag Checksum Error
    or      byte ptr [bp+0Eh], 20h
loc_F0A93:  

;       0F3F	jz short 0xF49
    ORG     0f3fh
;    jz      short loc_F0F49
    jmp      short loc_F0F49
    or      byte ptr [bp+3Fh], 1 ; Flag BIOS Checksum error
    or      byte ptr [bp+0Eh], 20h
loc_F0F49:                              ; CODE XREF: seg000:0F2D↑j


;		1A37	jz short 0x1A3F				74 06				-> EB 06
    ORG     1A37h
;    jz      short loc_F1A3F
    jmp      short loc_F1A3F
    mov     al, 0ADh
    out     64h, al         ; 8042 keyboard controller command register.
                            ; Disable keyboard.
loc_F1A3D:                              ; CODE XREF: seg000:loc_F1A3D↓j
    jmp     short loc_F1A3D
loc_F1A3F:                              ; CODE XREF: seg000:1A37↑j

    ORG     1A66h
    jz      short ChecksumOKMaybe
    ORG     1A89h
ChecksumOKMaybe::

;****************************************************************************
; Redirect jumps in INT15h handler for funcs C1 & C2
;****************************************************************************

    ORG 0D601h

loc_FD601:                              ; CODE XREF: seg000:D5FC↑j
                cmp     ah, 0C1h
                jnz     loc_FD60B
;                jmp     loc_FD591
                jmp     INT15_MS
; ---------------------------------------------------------------------------
loc_FD60B:                              ; CODE XREF: seg000:D604↑j
                cmp     ah, 0C2h
                jnz     loc_FD615
;                jmp     loc_FD591
                jmp     INT15_MS
; ---------------------------------------------------------------------------
loc_FD615:                              ; CODE XREF: seg000:loc_FD591↑j

;****************************************************************************
; Redirect IRQ12 ISR
;****************************************************************************
    ORG 083B9h
;                mov     word ptr ds:1D0h, offset locret_FD590
                mov     word ptr ds:1D0h, offset IRQ12


;****************************************************************************
; Fix HDD Display Bug
; Thanks to Jan Steunebrink :)
;****************************************************************************
    ORG 0578Bh
;                mov     ax, [bp+94h]
;                xor     ch, ch
;                mov     cl, [bp+96h]
;                mul     cx
;                mov     cl, [bp+9Bh]
;                shl     cx, 3
;                mul     cx
;                mov     cx, 3D09h
;                div     cx
;                mov     [bp+9Ch], ax

    mov al, [bp+96h]
    xor ch, ch
    mov cl, [bp+9bh]
    shl cl, 2
    mul cl
    mov cx, [bp+94h]
    mul cx
    mov cx, 2000h
    div cx
    mov [bp+9ch], ax

;****************************************************************************
; Fix AMD 5x86 CPU detection
;****************************************************************************

CPUTable_Entry  struc ; (sizeof=0x4, mappedto_3)
    ResetID dw ?
    Byte1   db ?
    Byte2   db ?
CPUTable_Entry  ends

; Patch CPU table entry
                ORG 082BCh
                dw offset CPUTable_AMD

                ORG 08051h
                dw offset CPUString_586NoWB
                dw offset CPUString_586WB

                ORG 0F800h
CPUString_586NoWB:
                db 'AMD ', 6, 'Am5x86', 8, 0
CPUString_586WB:
                db 'AMD ', 6, 'Am5x86-WB', 8, 0

                ORG 06130h
CPUTable_AMD    CPUTable_Entry <430h, 0C3h, 50h>
                CPUTable_Entry <470h, 0C3h, 58h>
                CPUTable_Entry <480h, 0C5h, 90h>
                CPUTable_Entry <490h, 0C5h, 98h>
                CPUTable_Entry <4E0h, 0D1h, 30h>
                CPUTable_Entry <4F0h, 0D3h, 38h>

;                CPUTable_Entry <4E0h, 0D1h, 30h>
;                CPUTable_Entry <4F0h, 0D3h, 38h>
                db 0FFh
                db 0FFh

CPU_BRAND_AMD		EQU	00000010b
SMI_TYPE_INTEL		EQU	00000001b

; CPU SMI type table entry
                ORG 0829Ch
                db CPU_BRAND_AMD, SMI_TYPE_INTEL
                db CPU_BRAND_AMD, SMI_TYPE_INTEL

                ORG 021D0h
RoundOffClock:
                ORG 021E0h
SysClockTbl:
                ORG 021A9h
Three_Freq::
                ORG 021BBh
Single_Freq::

; Override cpu multiplier check
; This is much harder than it seems because the code is copied and executed from memory, not from the ROM
; So we're in a different segment... We must call our hack as a far call, then jump back.

                ORG 21A9h
                FAR_JMP 0F000h, Multi4_Hack
;                FAR_CALL 0F000h, Multi4_Hack

                ORG 0FEB0h
Multi4_Hack:
                test    byte ptr [bp+3Fh], 20h ; Quadruple
                jz      short skip4
                mov     bl, 4
skip4:
                test    byte ptr [bp+3Fh], 80h ; Triple
                jz      short skip3
                mov     bl, 3
;                jmp     short loc_F21BB
skip3:                              ; CODE XREF: S_CPU_Speed_stuff+1A9↑j
                test    byte ptr [bp+3Fh], 40h ; Double
                jz      short chkDone
                mov     bl, 2
chkDone:                              ; CODE XREF: S_CPU_Speed_stuff+1AD↑j
                                        ; S_CPU_Speed_stuff+1B3↑j
                div     bl
                add     al, 3
                mov     dh, al
                mov     dl, bl
                mov     si, offset SysClockTbl
                mov     cx, 8
;                nop
;               idk how to do far calls in TINY model with MASM so here's this ugly hack :(
                FAR_CALL 0f000h, RoundOffClock
                retf

; Fix clock multiplier bit mask not applying properly because it's not aware of the 4x bit
                ORG 03DF2h
;                test    byte ptr [bp+3Fh], 0C0h
                test    byte ptr [bp+3Fh], 0E0h
                ORG 05E4h
;                test    byte ptr [bp+3Fh], 0C0h
                test    byte ptr [bp+3Fh], 0E0h

;****************************************************************************
; Functions provided by the BIOS already
;****************************************************************************

    ORG 0D59Ah
Send_Command_to_KC::
    ORG 0D594h
OUT_AUX::
    ORG 0C6FCh
OUT_8042_FULL::
    ORG 0EDCCh
WAIT_REFRESH::
    ORG 0D615h
int15_not_mouse::

    ORG 0DC70h
;Rmv1 start
;*****************************************************************************
; Procedure Name:	irq12
;	Pointing device hardware interrupt IRQ12 routine
;	Just process mouse data, don't care hand-shaking flag
;	Relative flag : device driver far call flag
;	Relative value : data package size and count index
; Saves:
; Inputs:	none
; Output:	affect data package size and count index
; Destroy:	none
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

        public	Irq12
irq12		proc	far

;		call	PM_Before_PS2_Mouse
        
		push	ax
		push	bx
		push	cx
		push	si
		push	di
		push	bp

		push	ds
        push    es                      
		cld
		in	al,DATA8042		; get mouse data

		sti
		mov	bx,G_RAM
		mov	ds,bx
		assume	ds:g_ram
		mov	bx, word ptr G_RAM:EXT_SEGMENT
		mov	ds,bx				; ds point to extended
		assume	ds:NOTHING			; data area

		mov	bl,byte ptr ds:PDFLG_1		; get current count idx
		and	byte ptr ds:pdflg_1,0f8h	; clear count index
		xor	bh,bh
		and	bl,07
		mov	byte ptr ds:auxdata[bx],al	; set mouse data
		mov	bh,byte ptr ds:PDFLG_2		; get data package size
		and	bh,07
		inc	bl
		cmp	bl,bh
		ja	do_far_call
		or	byte ptr ds:PDFLG_1,bl		; set new count index

		call	Check_DataPack			

		jmp	short irq12_ret
do_far_call:
		test	byte ptr ds:PDFLG_2,DDFCFLG	; check device service
		jz	short irq12_ret			; routine installed

		xchg	bl,bh
		xor	bh,bh			; bx contain data package size
		mov	cx,bx
		inc	cx			; data size loop
		mov	si,bx
		shl	si,1
		lea	bx,DGROUP:address_tbl
		mov	bx,word ptr cs:[bx+si]	; get xlat table address

		xor	ax,ax			; set stack and clear
		push	ax
		push	ax
		push	ax
		push	ax
		mov	bp,sp
		mov	si,auxdata
set_stack_loop:
		mov	al,byte ptr cs:[bx]	; get stack relative position
		mov	di,ax
		lodsb				; get mouse data
		mov	byte ptr [bp+di],al	; put it in stack
		inc	bx
		loop	set_stack_loop

		call	dword ptr ds:fcoffset	; call device service routine
		add	sp,08
irq12_ret:
		cli

;		call	PM_After_PS2_Mouse

		mov	al,END_OF_INT
		out	B8259,al 		; EOI to slave 8259
		NEWIODELAY
		out	A8259,al			; EOI to master 8259

        pop     es                            

		pop	ds

		pop	bp
		pop	di
		pop	si
		pop	cx
		pop	bx
		pop	ax

		iret
irq12		endp

;*****************************************************************************
; Procedure Name:	dis_kc_ms
;	disable auxiliary device output buffer full interrupt bit in keyboard
;	controller command byte
; Saves:
; Inputs:	cl = command byte
;               al = data byte
; Output:	cf = 1 : keyboard controller error
;		cf = 0 : successful
; Destroy:	ax, cx
;
;*****************************************************************************

        PUBLIC DIS_KC_MS
DIS_KC_MS	PROC	NEAR
		mov	cl,WRITE_CMD		; set command byte
		mov	al,65h			; forced value

        jmp short kc_ms_process
;        call Send_Command_to_KC

;		jnz	short dkm_err 		; error if input buffer full
;		clc
 ;       ret
;		jmp	short dkm_ret
;dkm_err:
;		stc
;dkm_ret:
;		ret
DIS_KC_MS	ENDP

;*****************************************************************************
; Procedure Name:	en_kc_ms
;	enable auxiliary device output buffer full interrupt bit in keyboard
;	controller command byte
; Saves:
; Inputs:	cl = command byte
;               al = data byte
; Output:	cf = 1 : keyboard controller error
;		cf = 0 : successful
; Destroy:	ax, cx
;*****************************************************************************
        
        PUBLIC EN_KC_MS
EN_KC_MS	PROC	NEAR

		mov	cl,WRITE_CMD		; set command byte
		mov	al,47h			; forced value
kc_ms_process::
        call Send_Command_to_KC
		jnz	short ekm_err 		; error if input buffer full
		clc
        ret
;		jmp	short ekm_ret
ekm_err:
		stc
ekm_ret:
		ret
EN_KC_MS	ENDP

;*****************************************************************************
; Procedure Name:	int15_ms
;	Pointing device handler INT 15 service routine
;	check the mouse function call C1, C2
;	far jmp to original INT15 if not mouse driver function call
; Saves:
; Inputs:	ah = function call
; Output:	none
; Destroy:	none
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************
        public	int15_ms
INT15_MS	PROC	NEAR
    test	byte ptr cs:[CONFIG_TABLE+5],04H
    jz int15_not_mouse

 ;   jz short int15ms_yeet

    cmp	ah,0c1h			
;	je short func_c1
    jne func_c2

    ; C1 will just fall through over here...

;   This can be omitted i think, C2 does this check also
;    push ax
;    push es
;    xor ax, ax
;    mov es, ax
;    assume es:nothing
;    test byte ptr es:Hardware,00000100b	; check if mouse exist
;    pop es
;    pop ax
;    jnz short func_c2

;		test	byte ptr cs:[CONFIG_TABLE+5],04H	
;		jnz	short Yes_Mouse
;		jmp	int15_not_mouse
;Yes_Mouse:

; start - added this code to solve WIN386/2.11 problem

;		cmp	ah,0c1h				
;		je	func_c1				
;       C2 already does this, wtf
;        push ax
;        push es
;        mov ax, G_RAM
;        mov es, ax
;	    test byte ptr es:Hardware,00000100b	; check if mouse exist
;		pop	es
;        pop ax
;		jnz short int15_ms_1
;		jmp	int15_not_mouse
;int15_ms_1:
;		jmp	func_c2

;int15ms_yeet:
;    jmp int15_not_mouse

INT15_MS	ENDP

;*****************************************************************************
; Procedure Name:	FUNC_C1
;	Mouse handler INT 15 service routine function C1h
;	Return extended BIOS data area
; Saves:
; Inputs:	ah = C1
; Output:	es = extended data area segment address
; Destroy:	none
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

func_c1 	proc	near
		push	ax
;		mov	ax,g_ram
        xor ax, ax
		mov	es,ax
		mov	ax,word ptr es:Ext_Segment
		mov	es,ax
		pop	ax
		iret
func_c1 	endp

;*****************************************************************************
; Procedure Name:	FUNC_C2
;	Mouse handler INT 15 service routine function C2h
;	Pointing device interface
;
;	Contain subfunctions list:
;
;	AL value | BL value | decription
;	---------+----------+-----------------------------------------
;	00	 |	    | Enable/disable pointing device
;	01	 |	    | Reset pointing device
;	02	 |	    | Set sample rate
;	03	 |	    | Set resolution
;	04	 |	    | Read device type
;	05	 |	    | Pointing device interface initialization
;	06	 | 00	    | Return status
;	06	 | 01	    | Set scalling 1:1
;	06	 | 02	    | Set scalling 2:1
;	07	 |	    | Device driver far call initialization
;
; Saves:
; Inputs:	ah = C2
;		al, bl = describe previously
; Output:	cf = 0 : successfully
;			ah = 00
;		cf = 1 : error
;			ah = 01 : invalid function call
;			ah = 02 : invalid input
;			ah = 03 : interface error
;			ah = 04 : resend
;			ah = 05 : no far call installed
; Destroy:	none
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************
; input register values in stack

bp_subf 	equ	byte ptr [bp+10h]	;al
bp_cmd		equ	byte ptr [bp+0fh]	;bh
bp_seg		equ	word ptr [bp+02h]	;es
bp_offset	equ	word ptr [bp+0eh]	;bx

; output register values in stack

bp_flag 	equ	word ptr [bp+16h]
bp_errcode	equ	byte ptr [bp+11h]	;ah
bp_bh		equ	byte ptr [bp+0fh]	;bh
bp_bl		equ	byte ptr [bp+0eh]	;bl
bp_cl		equ	byte ptr [bp+0ch]	;cl
bp_dl		equ	byte ptr [bp+0ah]	;dl

FUNC_C2 	PROC	NEAR

		test	al,0f8h
		jz	short correct_subf

		mov	ah,01			; invalid subfunction
		stc				; set cf=1
		retf	2

correct_subf:
		push	ax			;bp+10
		push	bx			;bp+0e
		push	cx			;bp+0c
		push	dx			;bp+0a
		push	si			;bp+08
		push	di			;bp+06
		push	ds			;bp+04
		push	es			;bp+02
		push	bp			;bp
		mov	bp,sp

		mov	ax,g_ram
		mov	es,ax
		assume	es:g_ram

		mov	ax,es:Ext_Segment
		mov	ds,ax
		assume	ds:nothing

		call	dis_kc_ms		; disable AOBF interrupt

		test	byte ptr es:Hardware,00000100b	; mouse flag
		jz	short error_03

		xor	ah,ah
		mov	al,bp_subf
		shl	ax,1			; *2(word)
		lea	si,DGROUP:subftbl		; point to subf address table
		add	si,ax
		jmp	word ptr cs:[si]

succ_00::
		mov	bp_errcode,0		; no error
		and	bp_flag,0fffeh		; clear carry falg in stack
		jmp	short func_c2_ret
error_01::
		mov	bp_errcode,01		; invalid function call
		jmp	short func_c2_error
error_02::
		mov	bp_errcode,02		; invalid input
		jmp	short func_c2_error
error_03::
		mov	bp_errcode,03		; interface error
		jmp	short func_c2_error
error_05::
		mov	bp_errcode,05		; no far call installed
func_c2_error::
		or	bp_flag,01		; set carry flag in stack

func_c2_ret::
		call	en_kc_ms		; enable AOBF interrupt

		pop	bp
		pop	es
		pop	ds
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		iret
FUNC_C2 	ENDP

;*****************************************************************************
; Procedure Name:	subf_01
;	Reset pointing device
;	mouse status after successfully reset:
;		- data transmission	= disable
;		- sampling rate 	= 100 reports/second
;		- resolution		= 4 counts/millimeter
;		- scalling		= 1:1
;		- mode			= stream mode
; Saves:
; Inputs:	none
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 03 : interface error
;				= 04 : resend
;		bp_bl (BL) = first byte of device response
;		bp_bh (BH) = device id (mouse:00)
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

SUBF_01 	PROC	NEAR
;Clear mouse buffer Before send command to mouse
		and	byte ptr ds:pdflg_1,0f8h	; clear count index
		mov	cl,10			; number of retry
ReSend:
		push	cx
		mov	al,MS_RESET		; reset mouse command
		call	out_aux
		pop	cx

		jnz	short error_03		; interface error
		call	wait_ack		; wait response and set status
		jz	short Get_Id		; ACK received ?
		dec	cl			; no ,resend command
		jnz	short ReSend
						; retry time-out
		or	bp_errcode,0		; affect ZF
		jmp	short func_c2_ret
get_id:
		call	get_data		; wait AOBF and get data
		jz	short error_03		; error if no AOBF
		mov	bp_bl,al		; first byte device response

		call	get_data		; wait AOBF and get data
		jz	short error_03		; error if no AOBF
		mov	bp_bh,al		; device id

		jmp	short succ_00		; successful
SUBF_01 	ENDP



;*****************************************************************************
; Procedure Name:	subf_00
;	Enable/disable pointing device
; Saves:
; Inputs:	bp_bh (BH) = 00 disable
;			   = 01 enable
;		device driver far call flag
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 01 : invalid function
;				= 03 : interface error
;				= 04 : resend
;				= 05 : no far call installed
; Destroy:	ax, bh, cx
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************


SUBF_00 	PROC	NEAR
		mov	al,bp_bh
		test	al,0feh
		jnz	short error_01		; invalid function
chk_fcflg:
		test	byte ptr ds:PDFLG_2,DDFCFLG
		jz	short error_05		; no far call installed
send_encmd:
						; en=01,dis=00
		xor	al,01			; xlat to en=00,dis=01
		add	al,MS_ENDATA		; en=00+f4,dis=01+f4=f5
		call	out_aux
		jnz	short error_03		; interface error
wait_subf00_ack:
		call	wait_ack		; wait response and set status
		jmp	short func_c2_ret
SUBF_00 	ENDP

;*****************************************************************************
; Procedure Name:	subf_02
;	Set sampling rate
; Saves:
; Inputs:	bp_bh (BH) = sample rate value (00 - 06)
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 02 : invalid input
;				= 03 : interface error
;				= 04 : resend
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

SUBF_02 	PROC	NEAR
		cmp	bp_bh,06
		ja	short error_02		; invalid input
correct_rate:
		mov	al,ms_setrate		; set sampling rate command
		call	out_aux
		jnz	short error_03		; interface error
wait_subf02_ack:
		call	wait_ack		; wait response and set status
		jnz	short func_c2_ret
send_rate:
		lea	si,DGROUP:smplrate		; point to translate table
		xor	ah,ah
		mov	al,bp_bh
		add	si,ax
		lodsb
		call	out_aux 		; out sampling rate to mouse
		jz	short wait_subf02_ack1	; ok, if no IBF
		jmp	error_03		; interface error
wait_subf02_ack1:
		call	wait_ack		; wait response and set status
		jmp	func_c2_ret
SUBF_02 	ENDP

; sampling rate translate table

smplrate	label	byte	; bh input	; reports per second
		db	0ah	; 00		; 10 reports/second
		db	14h	; 01		; 20 reports/second
		db	28h	; 02		; 40 reports/second
		db	3ch	; 03		; 60 reports/second
		db	50h	; 04		; 80 reports/second
		db	64h	; 05		; 100 reports/second
		db	0c8h	; 06		; 200 reports/second

;*****************************************************************************
; Procedure Name:	subf_03
;	Set resolution
; Saves:
; Inputs:	bp_bh (BH) = resolution value (00 - 03 counts per millimeter)
;			   = 00 : 1 count/millimeter
;			   = 01 : 2 counts/millimeter
;			   = 02 : 4 counts/millimeter
;			   = 03 : 8 counts/millimeter
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 02 : invalid input
;				= 03 : interface error
;				= 04 : resend
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

SUBF_03 	PROC	NEAR
		cmp	bp_bh,03
		jbe	short correct_res
		jmp	error_02		; invalid input
correct_res:
		mov	al,ms_setres		; set resolution command
		call	out_aux
		jz	short wait_subf03_ack 	; ok, if no IBF
		jmp	error_03		; interface error
wait_subf03_ack:
		call	wait_ack		; wait response and set status
		jz	short send_res		; ok, if get acknowledge
		jmp	func_c2_ret
send_res:
		mov	al,bp_bh		; resolution value
		call	out_aux
		jz	short wait_subf03_ack1	; ok, if no IBF
		jmp	error_03		; interface error
wait_subf03_ack1:
		call	wait_ack		; wait response and set status
		jmp	func_c2_ret
SUBF_03 	ENDP

package_tbl	label	byte
; define the position in stack
; data position -	0,1,2,3,4,5,6,7 ; in extended data area
					; data package size
size1		db	6		; 1
size2		db	6,7		; 2
size3		db	6,4,2		; 3
size4		db	6,7,4,2 	; 4
size5		db	6,4,2,5,3	; 5
size6		db	6,7,4,2,5,3	; 6
size7		db	6,4,2,0,5,3,1	; 7
size8		db	6,7,4,2,0,5,3,1 ; 8

;*****************************************************************************
; Procedure Name:	subf_04
;	Read auxiliary device type
; Saves:
; Inputs:	none
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 03 : interface error
;				= 04 : resend
;		bp_bh (BH) = device id (mouse:00)
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

SUBF_04 	PROC	NEAR
		mov	al,ms_rdtype		; read device type command
		call	out_aux
		jz	short wait_subf04_ack 	; ok, if no IBF
		jmp	error_03		; interface error
wait_subf04_ack:
		call	wait_ack		; wait response and set status
		jz	short get_type		; ok, if get acknowledge
		jmp	func_c2_ret
get_type:
		call	get_data		; wait AOBF and get data
		jz	short no_echo_type		; error if no AOBF
		mov	bp_bh,al		; set device id

		jmp	succ_00 		; successful
no_echo_type:
		jmp	error_03		; interface error
SUBF_04 	ENDP

;*****************************************************************************
; Procedure Name:	subf_05
;	Pointing device interface initialization
;	- set data package size
;	- execute reset command, if fail, then try 3 times
; Saves:
; Inputs:	bp_bh (BH) = data package size (01 - 08 bytes)
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 02 : invalid input
;				= 03 : interface error
;				= 04 : resend
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

SUBF_05 	PROC	NEAR
		or	bp_bh,00		; check data package size
		jz	short incorrect_size
		cmp	bp_bh,08
		jbe	short correct_size
incorrect_size:
		jmp	error_02		; invalid input
correct_size:
		and	byte ptr ds:pdflg_2,0f8h
		mov	al,bp_bh
		dec	al
		or	byte ptr ds:pdflg_2,al
		mov	bh,03			; try 3 times if fail
rstloop:
		mov	al,ms_reset		; reset command
		call	out_aux
		jz	short wait_subf05_ack 	; ok, if no IBF
		jmp	short subf05_error
wait_subf05_ack:
		call	wait_ack		; wait response and set status
		jnz	short subf05_error		; jmp if error occur
		call	get_data		; wait AOBF and get data
		jz	short subf05_error		; error if no AOBF
		call	get_data		; wait AOBF and get data
		jnz	short setdef_suc
subf05_error:
		dec	bh
		jnz	short rstloop
		jmp	error_03		; interface error
setdef_suc:
		jmp	succ_00 		; successful
SUBF_05 	ENDP

;*****************************************************************************
; Procedure Name:	subf_06
;	Extended commands
; Saves:
; Inputs:	bp_bl (BL) = extended command
;			   = 00 - Return status
;			   = 01 - Set scalling factor to 1:1
;			   = 02 - Set scalling factor to 2:1
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 01 : invalid function
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

SUBF_06 	PROC	NEAR
		mov	al,bp_bh
		or	al,al
		jz	short cmd_00
		dec	al
		jz	short cmd_01
		dec	al
		jz	cmd_02
		jmp	error_01		; invalid subfunction
SUBF_06 	ENDP

;*****************************************************************************
; Procedure Name:	cmd_00
;	return status
;	- execute auxiliary device status request command
;	- auxiliary device should sent 3 bytes status to system
; Saves:
; Inputs:	none
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 03 : interface error
;				= 04 : resend
;		bp_bl (BL) = status byte 1
;			bit 7	= reserved
;			bit 6	= 0 stream mode
;				= 1 remote mode
;			bit 5	= 0 disable data transmission
;				= 1 enable data transmission
;			bit 4	= 0 scaling 1:1
;				= 1 scaling 2:1
;			bit 3	= reserved
;			bit 2	= 1 left mouse button pressed
;			bit 1	= reserved
;			bit 0	= 1 right mouse button pressed
;		bp_cl (CL) = status byte 2
;			00 : 1 count/millimeter
;			01 : 2 counts/millimeter
;			02 : 4 counts/millimeter
;			03 : 8 counts/millimeter
;		bp_bl (DL) = status byte 3
;			0ah  : 10 reports/second
;			14h  : 20 reports/second
;			28h  : 40 reports/second
;			3ch  : 60 reports/second
;			50h  : 80 reports/second
;			64h  : 100 reports/second
;			0c8h : 200 reports/second
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

CMD_00		PROC	NEAR
		mov	al,ms_stsreq		; status request command
		call	out_aux
		jz	short wait_cmd00_ack		; ok, if no IBF
		jmp	error_03		; interface error
wait_cmd00_ack:
		call	wait_ack		; wait response and set status
		jz	short get_status		; ok, if get acknowledge
		jmp	func_c2_ret
get_status:
		call	get_data		; wait AOBF and get data
		jz	short no_echo_status		; error if no AOBF
		mov	bp_bl,al		; set 1st status byte

		call	get_data		; wait AOBF and get data
		jz	short no_echo_status		; error if no AOBF
		mov	bp_cl,al		; set 2nd status byte

		call	get_data		; wait AOBF and get data
		jz	short no_echo_status		; error if no AOBF
		mov	bp_dl,al		; set 3rd status byte

		jmp	succ_00 		; successful
no_echo_status:
		jmp	error_03		; interface error
CMD_00		ENDP

;*****************************************************************************
; Procedure Name:	subf_07
;	Device driver far call initialization
;	Set INT74 far call address with ES:BX and set far call flag (27:b.7)
;	Assume always no error occur
; Saves:
; Inputs:	bp_seg (ES)	= device driver routine segment
;		bp_offset (BX)	= device driver routine offset
; Output:	none
; Destroy:	ax
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	|		| NEW	| Initial revision
;
;*****************************************************************************

SUBF_07 	PROC	NEAR
		mov	ax,bp_seg
		mov	word ptr ds:fcsegment,ax
		mov	ax,bp_offset
		mov	word ptr ds:fcoffset,ax
		or	byte ptr ds:pdflg_2,ddfcflg
		jmp	succ_00 			; successful
SUBF_07 	ENDP



;*****************************************************************************
; Procedure Name:	cmd_01
;	set scaling factor 1:1
; Saves:
; Inputs:	none
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 03 : interface error
;				= 04 : resend
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

CMD_01		PROC	NEAR
		mov	al,ms_rstscl		; reset scaling command
		jmp	do_scale
CMD_01		ENDP


;*****************************************************************************
; Procedure Name:	wait_ack
;	long loop to get the mouse response for system's command
; Saves:
; Inputs:	none
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 03 : interface error
;				= 04 : resend
;		zf = 1 : acknowledge received
;		zf = 0 : error occur
; Destroy:	ax
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

WAIT_ACK	PROC	NEAR
		push	cx
wait_ack1:
		xor	cx,cx
wait_oaf_loop:
		push	cx
		call	out_aux_full
		pop	cx
		jnz	short get_ack
		loop	short wait_oaf_loop
		jmp	short wa_error_03	; time out
get_ack:
		in	al,data8042
		cmp	al,ackcode		; check acknowledge code
		je	short wa_suc
chk_rsnd_code:
		cmp	al,rscode		; check resend code
		jne	short chk_error_code
		mov	bp_errcode,04
		jmp	short wa_error
chk_error_code:
wa_error_03:
		mov	bp_errcode,03
wa_error:
		and	byte ptr ds:pdflg_1,0f0h
		or	bp_flag,01		; set carry flag
		jmp	short wa_ret
wa_suc:
		mov	bp_errcode,00
		and	bp_flag,0fffeh		; clear carry flag
wa_ret:
		pop	cx
		or	bp_errcode,0		; affect ZF
		ret
WAIT_ACK	ENDP

;*****************************************************************************
; Procedure Name:	get_data
;	receive data from mouse if Auxiliary device Output Buffer Full
; Saves:
; Inputs:	none
; Output:	zf = 1 : no data received
;		zf = 0 : successful
;			al = data byte received
; Destroy:	ah
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

GET_DATA	PROC	NEAR
		push	cx
		xor	cx,cx
gd_loop:
		push	cx
		call	out_aux_full		; check AOBF
		pop	cx
		jnz	short receive_data
		loop	short gd_loop
		jmp	short gd_ret
receive_data:
		in	al,data8042
gd_ret:
		pop	cx
		ret
GET_DATA	ENDP



;*****************************************************************************
; Procedure Name:	cmd_02
;	set scaling factor 2:1
; Saves:
; Inputs:	none
; Output:	bp_flag : cf = 0 : no error
;			  cf = 1 : error
;		bp_errcode (AH) = 00 : no error
;				= 03 : interface error
;				= 04 : resend
; Destroy:
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

CMD_02		PROC	NEAR
		mov	al,ms_setscl		; set scaling 2:1 command
do_scale::
		call	out_aux
		jz	short wait_cmd02_ack		; ok, if no IBF
		jmp	error_03		; interface error
wait_cmd02_ack:
		call	wait_ack		; wait response and set status
		jmp	func_c2_ret
CMD_02		ENDP


;*****************************************************************************
; Procedure Name:	out_aux_full
;	Check for 8042 auxiliary device output buffer full
; Saves:
; Inputs:	none
; Output:	al = status register value
;		zf = 0 : auxiliary device output buffer full
;		zf = 1 : no auxiliary device output buffer full
; Destroy:	ax, cx
; Author:	Ken Chen
; Date: 	06/21/90
;
; Rev	| Name	| Date		| TPR#	| Description
; ------+-------+---------------+-------+-------------------------------------
; 1.00	| Ken	| 06/21/90	| NEW	| Initial revision
;
;*****************************************************************************

		PUBLIC	OUT_AUX_FULL
OUT_AUX_FULL	PROC	NEAR
		call	out_8042_full
		jz	short no_aux_full
		test	al,OBF_AUX
no_aux_full:
		ret
OUT_AUX_FULL	ENDP


;*****************************************************************************
;
;   This stuff is required by IRQ12.
;
;*****************************************************************************

        public Check_DataPack
Check_DataPack	proc	near
                mov     cx,5*33
delay_lp:
                in      al,STAT8042
                iodelay
                sti
                and     al,21h
                cmp     al,21h
                je      short irq12exit

                push    cx
                push    bx

                mov cx,1
        		xor	bx,bx

                call    wait_refresh


                pop     bx
                pop     cx
                loop    short delay_lp

                ;Time out
                and     byte ptr ds:PDFLG_1, 11111000b         ;rest count index
                mov     ax,ds
                mov     es,ax
                cld
                lea     di,ds:auxdata
                xor     ax,ax
                stosw
                stosw
                stosw
                stosw

irq12exit:
		ret
Check_DataPack	endp

; Since DFC0 - DFDF is off limits, we need to put these somewhere else.
; Just in case the other stuff gets overwritten, too, we put it far away...
    ORG 0F530h

    public subftbl
subftbl 	label	word
		dw	offset DGROUP:subf_00
		dw	offset DGROUP:subf_01
		dw	offset DGROUP:subf_02
		dw	offset DGROUP:subf_03
		dw	offset DGROUP:subf_04
		dw	offset DGROUP:subf_05
		dw	offset DGROUP:subf_06
		dw	offset DGROUP:subf_07

    public address_tbl
address_tbl	label	word
		dw	offset DGROUP:size1
		dw	offset DGROUP:size2
		dw	offset DGROUP:size3
		dw	offset DGROUP:size4
		dw	offset DGROUP:size5
		dw	offset DGROUP:size6
		dw	offset DGROUP:size7
		dw	offset DGROUP:size8

; We should be at exactly E000 now... 

FCODE ENDS

    END
